# Assignment 3 (CPSC501W25)
> Homer Riva-Cambrin (30173233)

# Repository
https://csgit.ucalgary.ca/homer.rivacambrin/cpsc501a3

# Project Setup
The project is set up in such a way that you can just run it in Eclipse. We are using JUnit 5 and the following VM flags **must** be used:
```bash
--add-opens java.base/java.lang=ALL-UNNAMED
--add-opens java.base/java.util=ALL-UNNAMED
```


# Tests
The software has a comprehensive set of test cases written in JUnit 5. The tests check that the structure that is extracted from the various classes is as expected. sWe can do this because inspection extracts into a `Node` and thus we can verify that the tree generated is created.

# Refactors
- (63edce4b1fe162d920ea475a371328c741c48d08) The `Node` class is used for building out an information tree that can then be rendered. There were previously several different possible functionalities depending on the "subtype" which was determined by setting some variables. As such, subclasses were abstracted out reducing code duplication and making the codebas easier to read/understand.
- (b44c0905c939d4debf18e39fa7bf1333d1bae835) The `properInspection` method had code for exploring the interfaces. In the other parts of the code these are made into their own respective methods, so that was done for the interface extraction. This makes the code easier to read and prevents one method handling many different things.