package com.nodes;

/**
 * This is a node that just holds a K/V pair.
 * 
 * When rendered it looks lik:
 * Key: Value
 */
public class InfoNode  extends Node {
	// The value.
    String datum;

    /**
     * Creates a new information node.
     * @param depth: the depth of he node
     * @param title: the key
     * @param data: the value.
     */
    public InfoNode(int depth, String title, String data) {
        super(depth, title, false);
        this.datum = data;
    }

    @Override
    public void render(boolean tabulate) {
        this.renderTitle(false, tabulate);

        System.out.println(this.datum);
        
        super.render(tabulate);
    }
}
